diff --git a/libr/bin/format/pe/pe.c b/libr/bin/format/pe/pe.c
index 6aaec760347..e6b41adcc55 100644
--- a/libr/bin/format/pe/pe.c
+++ b/libr/bin/format/pe/pe.c
@@ -1952,7 +1952,7 @@ struct r_bin_pe_import_t* PE_(r_bin_pe_get_imports)(struct PE_(r_bin_pe_obj_t) *
 			bin->import_directory_size = bin->size - bin->import_directory_offset;
 		}
 		last = (char *)curr_import_dir + bin->import_directory_size;
-		while ((void*)curr_import_dir < last && (
+		while (((void*)curr_import_dir + sizeof (PE_(image_import_directory))) < last && (
 				curr_import_dir->FirstThunk != 0 || curr_import_dir->Name != 0 ||
 				curr_import_dir->TimeDateStamp != 0 || curr_import_dir->Characteristics != 0 ||
 				curr_import_dir->ForwarderChain != 0)) {
@@ -2051,7 +2051,7 @@ struct r_bin_pe_lib_t* PE_(r_bin_pe_get_libs)(struct PE_(r_bin_pe_obj_t) *bin) {
 			//return NULL;
 		}
 		last = (char *)curr_import_dir + bin->import_directory_size;
-		while ((void*)curr_import_dir < last && (
+		while (((void*)curr_import_dir + sizeof (PE_(image_import_directory)))< last && (
 				curr_import_dir->FirstThunk != 0 || curr_import_dir->Name != 0 ||
 				curr_import_dir->TimeDateStamp != 0 || curr_import_dir->Characteristics != 0 ||
 				curr_import_dir->ForwarderChain != 0)) {
